#!/usr/bin/tclsh
#(c) pull
#imdb-dir 1.03
#initial release: sometime 2003
#last update 29/09/2004
#
#An IMDB script for those who like to keep things simple
#
#Features:
#1) Create a directory with IMDB information in its name
#2) Create a shorturl for quick access with IE/Mozilla/Netscape/Opera/Lynx....
#3) Sends a for botoutput optimized string to the glftpd.log
#4) Can be run from cron or zipscript
#
#Requirements:
#1)Probably tcl 8.4+ I havent tried on earlier versions of tcl.
#2)A working tclsh in /glftpd/bin/
#
#installation:
#use your zipscript to execute readnfo.tcl on every nfo upload.
#If you're using zipscript-c I recommend using the nfo patch from psxc.
#zsconfig.h
##define enable_nfo_script       TRUE
##define nfo_script              "/bin/readnfo.tcl"
#
#The script is run from crontab
#*/1 * * * *     /glftpd/bin/imdb-dir.tcl >/dev/null 2>&1
#
#
#todo: 
#do some documentation
#clean up messy code
#create a global config file
#
#changelog:
#13/08/04 added browser identification
#29/09/04 fixed a small bug in the imdb url grabber
#29/09/04 adjusted script to an imdb layout change(genre)
#29/09/04 option to run the script from the zipscript independent from cron.
#
#example:
#<date> <trigger> <name of movie> <rating> <votes> <genre> <runtime in minutes>
#Sun Jan 18 21:05:01 2004 IMDB: "Recruit, The (2003)" "http://german.imdb.com/title/tt0292506/" "6.6" "7,686" "Thriller" "115"
#
#for dark0n3's dZSbot.tcl
#set msgtypes(DEFAULT) "IMDB"
#set disable(IMDB)          0
#set variables(IMDB) "%title %url %rating %votes %genre %length"
#set announce(IMDB)  "\(%boldIMDB%bold\) %bold%title%bold has a rating of %bold%rating/10%bold with %bold%votes%bold votes"
package require http 
######################################################
######################################################
set gldir 	"/glftpd"
if { [file exists $gldir] == 0 } {
	set gldir	""
}
puts "gldir: $gldir"
set log 	"$gldir/ftp-data/logs/imdb.log"
set gllog	"$gldir/ftp-data/logs/glftpd.log"
set groupdir	"/site/groups"
set reqdir	"/site/stats"
set createdir 	"1"
set createurl	"1"
set botout	"0"
set bottag	"IMDB:"
set debug       "1" 
######################################################
######################################################

########not for you###################################
set foundruntime "0"
set foundgenre 	"0"
set foundtitle  "0"
set minutes 	"na"
set genre 	"na"
set rating 	"not availabe"
set votes 	"na"
set title	"no-title-found"
set agent       "Mozilla 5.0 (compatible)"

proc dputs {in} {
	global debug
	if {$debug != 0} {
		puts "$in"
	}
}

if { [file exists $log] != 1} {
	dputs "logfile not found"
	exit 0	
}

set in [open $log r]

while {![eof $in]} {
	set line [gets $in]
	set url [lindex [split $line ";"] 0]
	set pwd [lindex [split $line ";"] 1]


if { $argc > 0 } {
	set url [lindex $argv 0]
}

if { $url == ""} {
	dputs "url empty: stopping while loop"
	break
} else { dputs "URL: $url" }

http::config -useragent "$agent"
set retval [catch {set token [::http::geturl $url]}]
if { $retval == 1 } {
	break
}
upvar #0 $token state
foreach line [split $state(body) \n] {
	if { $foundruntime == 1} {
		set foundruntime 0
		set minutes [lindex [split $line " "] 0 ]
		if { [string match *:* $minutes ] == 1 } {
			set minutes [lindex [split $minutes ":"] 1 ]
		}
	}

	if { $foundgenre == 1} {
		set foundgenre 0
		regsub -all {<a href="/rg/title-tease/keywords/title/tt0379217/keywords">} $line "" line
		regsub -all {<a href="/Sections/Genres/} $line "" line
		regsub -all {</a>} $line "" line
		regsub -all {<a href="keywords">\(more\)} $line "" line
		regsub -all {/\">} $line " " line
		set genre1 [lindex [lindex [split $line "/"] 0] 0]
		set genre2 [lindex [lindex [split $line "/"] 1] 0]
		set genre3 [lindex [lindex [split $line "/"] 2] 0]
		set genre4 [lindex [lindex [split $line "/"] 3] 0]
		set genre "$genre1 $genre2 $genre3 $genre4"
		regsub -all " " $genre "," genre
		regsub -all {,,,} $genre "" genre
		regsub -all {,,} $genre "" genre
		}
	
	if { [string match *votes* $line ] == 1 } {
		regsub -all {[(<>)b]} $line "" line
		set rating "[lindex [split [ lindex $line 0] "/"] 0]/[lindex [split [ lindex $line 0] "/"] 1]"
		set votes [ lindex $line 1]
		regsub -all {/} $rating "(" rating
	}
	if { [string match *Genre:* $line ] == 1 } {
		set foundgenre 1
	}
	if { [string match *Runtime* $line ] == 1 } {
		set foundruntime 1
	}

	if { [string match *l\;nge:* $line ] == 1 } {
		set foundruntime 1
	}

	if { $botout == 1 } {
		if { [string match <title>* $line ] == 1 } {
			regsub {^<title>} $line "" line
			regsub {</title>} $line "" line
			set title "$line"
		}
	}
}
# end of foreach loop

if { [string match *awaiting* $rating ] == 1 } {
	set votes "na"
	set rating "awaiting 5 votes"
}

dputs "Path: $pwd"
dputs "Runtime: $minutes minutes"
dputs "Genre: $genre"
dputs "Rating: $rating"
dputs "Votes: $votes"

if { [file isdirectory $gldir$pwd] == 1 } {

if { $createdir == 1} {
		set dir1 "$gldir$pwd/\-\ \[IMDB-0\]\ Rating\:\ $rating\)\ with\ $votes\ Votes"
		set dir2 "$gldir$pwd/\-\ \[IMDB-1\]\ Genre\:\ $genre\ Runtime\:\ $minutes\ minutes"
		file mkdir $dir1
		file mkdir $dir2
		file attributes $dir1 -permissions 040777
		file attributes $dir2 -permissions 040777
}

if { $botout == 1} {
	if { [string match $groupdir* $pwd] == 0 && [string match $reqdir* $pwd] == 0 } {
		set date [clock format [clock seconds] -format "%a %b %d %H:%M:%S %Y" ]
		set botlog [open $gllog a+]
		regsub {\(} $rating "/" rating
		set rating [lindex [split $rating "/"] 0]
		set retval [catch {puts $botlog "$date $bottag \"$title\" \"$url\" \"$rating\" \"$votes\" \"$genre\" \"$minutes\""}]
		if { $retval == 1 } {
			close $botlog
		}
	}
}

if { $createurl == 1} {
	set relname [string tolower [lindex [split $pwd "/"] end] ]
	set urlout [open $gldir$pwd/$relname.url a+]
	if {[regexp {//$} $url] == 1} {
		regsub {//$} $url "/" url
	}
	puts $urlout "\[InternetShortcut\]"
	puts $urlout "URL=$url"
	close $urlout
	file attributes $gldir$pwd/$relname.url -permissions 040777
}
}

}
# end of while loop
dputs "deleting logfile"
file delete -force $log
exit 0
